#include "hdtree.h"
#include <string>
#include <sstream>
#include "mtimer.h"

using namespace std;


void confl(int curlvl, int thresh, int Bsize, vector <segment> & smpl, vector <uint> &unsmpl, vector<segment>& vlst, 
	   double & ussize, double & insertc, double & qnode, double & telapsed, 
	   double &timeqtree, double &timebtree, double &timeflushCFL,
	   char* inputfile, Random& rng)
{
  char argv[100]="";
  sprintf(argv,"S%d",curlvl);
  char buf[100]="";
  sprintf(buf,"mkdir -p %sIndex/%s/",inputfile, argv);
  system(buf);
  sprintf(buf,"%sIndex/%s/",inputfile, argv);
  HDTree* hdtree=new HDTree(smpl, &rng);
  smpl.clear();

  MTimer t,t1,t2,t3,skytm;

  t.go();
  t1.go();
  hdtree->buildtree(buf);
  t1.stop();
  t1.update();
  timebtree+=t1.elapsed;

  //vector <segment> tmp;
  //  readsmpl r(unsmpl,tmp);
  segment s;

  // cerr<<" "<<endl;
  double usmplsize=unsmpl.size();
  unsigned long int insertcount=0;
  unsigned long qnodecount=0;
  unsigned long int j=0;
  uint unsplIndex=0;
  t2.go();
  while(j!=usmplsize)
    {
      unsplIndex=unsmpl[j];	
      hdtree->insert2confl(vlst[unsplIndex], unsplIndex);
      j++;
    }//while
  insertcount+=hdtree->count;
  qnodecount+=hdtree->qnodecount;
  t2.stop();
  t2.update();
  timeqtree+=t2.elapsed;
  sprintf(buf,"mkdir -p %sIndex/%s/C",inputfile, argv);
  system(buf);
  //sprintf(buf,"rm -f %s/C/*",argv);
  //system(buf);
  hdtnode * lastlvl=hdtree->firstlst.back();
  hdtnode * rec=lastlvl;
  hdtnode * follow=lastlvl;
  int objid=lastlvl->s.objid;
  int segid=lastlvl->s.segid;
  //  int i=0;
  fstream os,os1;
  segment envseg;
  uint ppos=0;
  sprintf(buf,"%sIndex/%s/env",inputfile,argv);
  os1.precision(12);
  os1.open(buf,ios::out);

  t3.go();
  lastlvl=lastlvl->sibling;
  while(lastlvl!=NULL)
    {
      if(lastlvl->s.objid==objid&&lastlvl->s.segid==segid)
	{
	  follow=lastlvl;
	  lastlvl=lastlvl->sibling;
	}
      else
	{
	
	  sprintf(buf,"%sIndex/%s/C/C",inputfile, argv/*,i++*/);
	  if(rec->pconfl->size()<=thresh*pow(2.0,curlvl)*Bsize||thresh==0)
	    ppos=SDB::outputConflictList(vlst, *(rec->pconfl), buf);
	  envseg=rec->s;
	  envseg.end=follow->s.end;
	  os1<<envseg<<" "<<rec->pconfl->size()<<" "<<rec->distinctObj<<" "<<ppos<<"\n";
	  /////////////////////////////////
	  rec->pconfl->clear();
	  //rec->objmap.clear();
	  delete(rec->pconfl);	 
	  rec->pconfl=NULL;		 
          /////////////////////////////////
	  objid=lastlvl->s.objid;
	  segid=lastlvl->s.segid;
	  rec=lastlvl;
	  follow=lastlvl;
	  lastlvl=lastlvl->sibling;	  
	}
    }

  sprintf(buf,"%sIndex/%s/C/C",inputfile,argv/*,i*/);
  if(rec->pconfl->size()<=thresh*pow(2.0,curlvl)*Bsize||thresh==0)
      ppos=SDB::outputConflictList(vlst, *(rec->pconfl), buf);
  envseg=rec->s;
  envseg.end=follow->s.end;
  os1<<envseg<<" "<<rec->pconfl->size()<<" "<<rec->distinctObj<<" "<<ppos<<endl;
  delete(rec->pconfl);
  rec->pconfl=NULL;
  os1.close();
  t.stop();
  t.update();
  t3.stop();
  t3.update();
  ussize+=usmplsize;
  insertc+=insertcount;
  qnode+=qnodecount;
  telapsed+=t.elapsed;
  timeflushCFL+=t3.elapsed;


  /*******deallocate********/
  //  tmp.clear();
  unsmpl.clear();
  delete hdtree;

  /*while(!lst.empty())
    {
      hdtnode * cur=NULL, *next=NULL;
      cur=lst.back();
      lst.pop_back();
      if(cur==NULL)
	continue;
      next=cur->sibling;
      if(cur==&(c.root))
	break;
      while(next)
	{
	  delete(cur);
	  cur=next;
	  next=next->sibling;
	}
      delete(cur);
    }*/
}

int main(int argc, char * argv[])
{
  if(argc!=6)
    {
      cerr<<"Usage:./sample <datafile> <trick threshold> <Bsize> <kmax> <dataformat:0 for raw data, 1 for segment data>"<<endl;
      exit(1);
    }
  char trans[100]="";
  int thresh=atoi(argv[2]);
  int format=atoi(argv[5]);
  /**************/
  MTimer overall;
  overall.go();

  SDB sdb(argv[1]);
	if (format==0)
	  sdb.readData();
	else
	  sdb.readEasyData();
  int j=0,stop;
  int lstsize;
  int Bsize=(int)((double)(atoi(argv[3])*1024)/(double)Tools::OBJSIZE);  
  int kmax=atoi(argv[4]);

  //  cerr<<"read"<<endl;
  lstsize=sdb.N;
  double NB=0.0;
  NB=(double)lstsize/(double)Bsize;
  double srate=1.0/(double)Bsize;	
	if (kmax<Bsize)
	  stop=(int)ceil(sqrt(log(NB)/log(2.0)));
	else
 	  stop=(int)ceil(sqrt(log(NB)/log(2.0))+log((double)kmax/(double)Bsize)/log(2.0));
  double ussize=0,insertc=0,qnode=0,telapsed=0,timeflushCFL=0,
    timeqtree=0,timebtree=0;
  vector <uint> unsmplst;
  vector<segment> smplst;
  while(j<=stop)
    {
      sdb.sample(srate,smplst, unsmplst);
      confl(j,thresh,Bsize,smplst,unsmplst,sdb.segs,
      ussize,insertc,qnode, telapsed,
      timeqtree,timebtree,timeflushCFL, argv[1], sdb.rng);
      // cerr<<j<<endl<<flush;
      j++;
      srate=srate/2.0;
      unsmplst.clear();
      smplst.clear();
    }
  /*trick thresh,total, total-readdata, build env, build HDT, query HDT, time computing intersection, total branch, outputCFL, touched CFL, total unsampled, touch CFL/total unsample, 
    total qtreetime/total unsample*/
  overall.stop();
  overall.update();
  cout<<sdb.N<<" "<<argv[2]<<" "<<overall.elapsed<<" "<<telapsed<<" "/*<<skytm<<" "*/<<timebtree<<" "<<timeqtree<<" "/*<<time_in_judge<<" " <<branch<<*/" "<<timeflushCFL<<" "<<insertc<<" "<<qnode<<" "<<ussize<<" "<<insertc/(double)ussize<<" "<<qnode/(double)ussize<<" "<<timeqtree/(double)ussize<<" "<<flush;
  ofstream indexfile;
  char filename[100]="";
  strcpy(filename, argv[1]);
  strcat(filename, "Index/config");
  indexfile.open(filename);
  indexfile<<j<<" "<<sdb.N<<endl;
  indexfile.close();

  sprintf(trans,"./buildBtree.exe %d %d %d %s",j,thresh,atoi(argv[3]),argv[1]);					 
  system(trans);								 
  return 0;
}
