#include "hdtree.h"

  HDTree::HDTree(vector<segment> smpl, Random* _rng)
  {
      vv.push_back(smpl);
      root=new hdtnode();
      /*root->s.start.x=0;
      root->s.start.y=1;
      root->s.end.x=Tools::xMAX;
      root->s.end.y=1;
      root->s.objid=Tools::MAX;
      root->s.segid=0;*/
      root->sibling=NULL;
      root->pconfl=NULL;
      height=0;
      _sampling();
      rng=_rng;
	count=0;
	qnodecount=0;
  } 

  HDTree::~HDTree()
 { 
	if (root!=NULL)
		delete root;
	firstlst.clear();	
	vv.clear();
 } 
  void HDTree::_sampling()
  {
    
    vector <segment>::iterator it; 
     while(vv.back().size()>4)
      {
	vector <segment> tmp;
	for(it=vv.back().begin();it!=vv.back().end();++it)
	  {
	    if(rng->uniform(0.0,1.0)>0.5)
		tmp.push_back((*it));
		//		o<<(*it)<<endl;
	  }
	vv.push_back(tmp);
      }
  }

  void HDTree::buildtree(char* path)
  {
    firstlst.push_back(root);
    while(vv.size())
      {
	//char sfile[100]="";
	//sprintf(sfile, "%ssamples%d",path,height);
	//SDB::printSegments(vv.back(),sfile);
	buildlvl(vv.back(), path);	
	height++;
	vv.back().clear();
	vv.pop_back();
      }
    //traverse leaf level again to setup right conflict list
    setupconflptr(firstlst[this->height]);
  }
  

  void HDTree::buildlvl(vector <segment> & D, char* path)
  {
    Envelope envlope;
    list <segment> res;
    hdtnode * p=firstlst[height];
    hdtnode * c=NULL;
    hdtnode * tmp=NULL;
    int rel;
	//char sfile[100]="";
	//sprintf(sfile, "%sorig_envelope%d",path,height);

    envlope.getenvlp(D, res);
    //SDB::printSegments(res,sfile);
    while(p!=NULL)
      {
	if(res.empty())
	  {
	    return;//will it come to here?
	  }
	segment us=p->s;
	segment ls=res.front();
	res.pop_front();
	//	cout<<"us:"<<us<<endl;
	//cout<<"ls:"<<ls<<endl;
	while(Tools::double_eq(ls.start.x,ls.end.x,6))
	  {
	    ls=res.front();
	    res.pop_front();
	  }
	rel=relation(us,ls);
	switch(rel)
	  {
	  case 0:
	    if(c==NULL)
	      {
		c=new hdtnode;
		firstlst.push_back(c);
		tmp=c;
	      }
	    else{
	      tmp=new hdtnode;
	      c->sibling=tmp;
	    }
	    tmp->s=ls;
	    tmp->pconfl=NULL;
	    p->child.push_back(tmp);
	    c=tmp;
	    if(Tools::double_eq(us.end.x,ls.end.x,6))
	      {
		hdtnode * perr=p;
		p=p->sibling;
		if(p)
		  {
		    if(res.empty())
		      {
			cerr<<"Somthing wrong 1"<<endl;
			exit(1);
		      }
		  }//if
		else
		  {
		    if(!res.empty())
		      {
			while(!res.empty())
			  {
			    if(res.front().start.x==Tools::xMAX)
			      res.pop_front();
			    else
			      {
				if(ls.end.x==Tools::xMAX)
				  break;
				cerr<<"Somthing wrong 2 res.size:"<<res.size()<<" "<<res.back()<<endl;
				cerr<<"Somthing wrong 2 stat p:"<<perr->s<<endl;
				exit(1);
			      }
			  }
			tmp->sibling=NULL;
			return;
		      }
		    else{
		      tmp->sibling=NULL;
		      return;
		    }
		  }//else
	      }//if
	    break;//contain
	  case 1://chop
	    segment seg=ls;
	    double x,y;
	    if(Tools::double_eq(ls.start.x,us.end.x,6))
	      {
		p=p->sibling;
		res.push_front(ls);
		if(p==NULL)
		  {
		    cerr<<"Somthing wrong 5"<<endl;
		    exit(1);
		  }//if
		break;
	      }
	    else
	      if((Tools::lineSegmentIntersection(ls.start.x,ls.start.y,
				    ls.end.x,ls.end.y,
				    us.end.x,0.5,
				    us.end.x,2*Tools::MAX,
				       &x,&y))==false)
	      {
		if(Tools::double_eq(ls.start.x,us.start.x,6)||
		   Tools::double_eq(ls.end.x,us.end.x,6))
		  {
		    x=ls.start.x;
		    y=ls.start.y;
		  }
		else
		if(!(ls.objid==us.objid&&ls.segid==us.segid))
		  {
		    cerr<<ls<<endl;
		    cerr<<us<<endl;
		    exit(1);
		  }
	      }
	    if(!Tools::double_eq(x,ls.start.x,6))
	      {
		seg.start.x=x;
		seg.start.y=y;
		res.push_front(seg);
		ls.end.x=x;
		ls.end.y=y;
	      }
	    //  cout<<"Minus: "<<seg<<endl;

	    if(c==NULL)
	      {
		c=new hdtnode;
		firstlst.push_back(c);
		tmp=c;
	      }
	    else
	      {
		tmp=new hdtnode;
		c->sibling=tmp;
	      }//else
	    tmp->s=ls;
	    tmp->pconfl=NULL;
	    p->child.push_back(tmp);
	    c=tmp;
	    p=p->sibling;
	    if(p==NULL)
	      {
		cerr<<"Somthing wrong 3"<<endl;
		exit(1);
	      }//if
	    break;//ls.end.x>us.end.x
	  }
      }
  }

  void HDTree::insert2confl(segment &s, uint index)
  {
    bool judge=false;
    int j=0;
    int childsize=0;
    q.push(root);
    vector<uint>* tmpptr=NULL;
    while(!q.empty())
      {
	t=q.front();
	q.pop();
	qnodecount++;
	judge=segment::is_in_traz(t->s,s);
	if(judge)
	  {
	    if(t->pconfl==NULL)//not leaf
	      {
		childsize=t->child.size();
		j=0;
		while(j!=childsize)
		  {
		    //    ++branch;
		    q.push((t->child)[j++]);
		  }//for
	      }//if
	    else//leaf,push in conflict
	      {
		if(tmpptr!=t->pconfl)
		  {
		    t->pconfl->push_back(index);
		    //t->insertConflict(s);
		    tmpptr=t->pconfl;
		    ++count;
		  }
	      }
	  }//if
      }//while
  }


  void HDTree::setupconflptr(hdtnode * first)
  {
    hdtnode * p=first;
    int objid,segid;
    if(first==NULL)
      {
	cerr<<"Something wrong 4"<<endl;
	exit(1);
      }
    objid=p->s.objid;
    segid=p->s.segid;
    vector<uint> * ptr=new vector<uint>;
    p->pconfl=ptr;
    p=p->sibling;
    while(p!=NULL)
      {
	if(p->s.objid==objid&&p->s.segid==segid)
	  {
	    p->pconfl=ptr;
	  }
	else
	  {
	    ptr=new vector<uint>;
	    p->pconfl=ptr;
	    objid=p->s.objid;
	    segid=p->s.segid;
	  }
	p=p->sibling;
      }
  }

  int HDTree::relation(segment us,segment ls)
  {
	int res=0;
    if( ( Tools::double_le(ls.start.x,us.start.x,6) || Tools::double_eq(ls.start.x,us.start.x,6) ) &&
       ( Tools::double_le(us.end.x,ls.end.x,6) || Tools::double_eq(us.end.x,ls.end.x,6) ) )
      res=0;//fully contain
    if( Tools::double_le(ls.end.x,us.end.x,6) && !Tools::double_eq(ls.end.x,us.end.x,6))
      res=1;
	return res;
  }
/*
  bool HDTree::is_in_traz(segment &ref, segment &q)
  {
    double x,y;
    if(Tools::double_le(ref.start.x, q.end.x,6)||
       Tools::double_le(q.start.x, ref.end.x,6))
      return false;
    if(Tools::double_eq_highp(ref.A, q.A, 0.0001))
      {
	if(Tools::double_le_highp(ref.B, q.B, 0.0001))
	  return false;
	else
	  return true;
      }//
    x=(ref.B-q.B)/(q.A-ref.A);
	y=q.A*x+q.B; 
    //if(double_le(x,ref.start.x,6)&&!double_eq(x,ref.start.x,6)&&double_le(ref.end.x,x,6)&&!double_eq(ref.end.x,x,6))
    //  return 1;
    if(Tools::double_le(ref.start.x,x,6))
      {
	if(Tools::double_le(q.A,ref.A,6))
	  return true;
	else
	  return false;
      }
    else if(Tools::double_le(x,ref.end.x,6))
      {
	if(Tools::double_le(ref.A,q.A,6))
	  return true;
	else
	  return false;
      }
    else if(Tools::double_le(q.end.y, y, 6) || Tools::double_le(q.start.y, y, 6))
	return true; 
    else  
	return false;
 } 
*/
