#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>
#include <ami_btree.h>
#include <ami_stream.h>
#include <ami_sort.h>
#include "ami_pb_tree.h"

//#include "pbsegwrapper.h"
#include "Random.h"
#define SIZE_OF_STRUCTURE 256
#define AMI_PBTREE AMI_per_btree<bkey_t, el_t, key_cmp_class, key_from_el>

typedef double bkey_t;// le

struct el_t {
  bkey_t key_;
  uint offset;
  char data_[SIZE_OF_STRUCTURE-sizeof(bkey_t)-sizeof(uint)];
  
  el_t(bkey_t k, uint pos): key_(k) 
  {
    offset=pos;
  }
  el_t() {}
};

struct key_from_el {
  bkey_t operator()(const el_t& v) const { return v.key_; }
};

typedef AMI_STREAM< el_t > stream_t;


class el_cmp_class{
public:
  bool compare(el_t &e1, el_t &e2)
  {
    if(e1.key_>e2.key_) 
      return true;
    else 
      return false;
  }
};


class key_cmp_class{
public:
  int compare(bkey_t &e1, bkey_t &e2)
  {
    if(e1>e2) 
      return true;
    else 
      return false;
  }
};


using namespace std;


int main(int argc, char **argv)
{
  el_cmp_class el_cmp_obj;
  uint el_num=0;
  double key=0;
  if(argc!=1)
    {
      cerr<<argv[0]<<" <# of elements>"<<endl;
      exit(0);
    }
  else
    {
      el_num=atol(argv[1]);
    }

  Random rand;
  char * base_file_stream = NULL;
  stream_t* is = (base_file_stream == NULL) ? new stream_t:
    new stream_t(base_file_stream);

  for(uint i=0; i<el_num;i++)
    {
      key=rand.uniform(1000,1000000)/100;
      is->write_item(el_t(key,i));
    }
  if ((is->seek(0))!= AMI_ERROR_NO_ERROR) {
    cout << "AMI_ERROR during is->seek()" << endl;
    exit(1);
  }

  stream* ot=new stream_t;
  if(AMI_sort(is,ot,&el_cmp_obj)!=AMI_ERROR_NO_ERROR)
    {
      cerr<<"Sort err."<<endl;
      exit(0);
    }
  
  if ((ot->seek(0))!= AMI_ERROR_NO_ERROR) {
    cout << "AMI_ERROR during ot->seek()" << endl;
    exit(1);
  }

  el_t *tmp;
  AMI_err ae;
  for(uint i=0; i<el_num;i++)
    {
      if ((ae = ot->read_item(&tmp)) != AMI_ERROR_NO_ERROR) {
	cout << "AMI_ERROR " << ae << " during source.read_item()" << endl;
         exit(1);
      }
      cout<<tmp->key_<<endl;
    }

  return 0;
}
