#ifndef _HDTREE
#define _HDTREE
#include <fcntl.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <queue>
#include <list>
#include <algorithm>
#include "cgalenvelop.h"
#include "sdb.h"
#include "segment.h"
#include "point.h"
#include "tools.h"
#include "rhdtnode.h"
#include "Random.h"

class RHDTree 
{
 public:	  
  rhdtnode* root;  
  vector < vector <segment> > vv;

  /************move out from insert2confl*********************/
  queue <rhdtnode *> q;
  Random* rng;
  rhdtnode * t;
  vector <rhdtnode *>::iterator myit;
  //MTimer myt;
  uint count;
  uint qnode;
  int height;
  int level;
  uint envsize;
  vector <rhdtnode *>  firstlst;
   lEnv* lenvfirst;	
  /********************************/

  RHDTree(vector<segment>  smpli, Random* _rng, int _level);
  ~RHDTree();

  void buildtree(char* path);
  void setupLeafLevel(rhdtnode * first);
  void buildlvl(vector <segment> & D, char* path);
  int relation(segment us,segment ls);
  void _sampling();
  void insert2confl(segment &s, uint index);
  void buildContainList(vector<RHDTree*>& trees);
  void writeConflictEnvelop(vector<segment>& segs, char* file);
 };
#endif
