#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>
#include <ami_btree.h>
#include <ami_stream.h>
#include <ami_sort.h>
#include "ami_pb_tree.h"

#include "Random.h"
#define SIZE_OF_STRUCTURE 256

#define AMI_PBTREE AMI_per_btree<el_t, el_t, pb_key_cmp_class, pb_key_from_el>

typedef double bkey_t;// le

struct el_t {
  bkey_t key_;
  uint offset;
  char data_[SIZE_OF_STRUCTURE-sizeof(bkey_t)-sizeof(uint)];
  
  el_t(bkey_t k, uint pos): key_(k) 
  {
    offset=pos;
  }
  el_t() {}
};

struct key_from_el {
  bkey_t operator()(const el_t& v) const { return v.key_; }
};

class pb_key_from_el {
public:
  el_t operator()(const el_t& v) const { return v; }
};

typedef AMI_STREAM< el_t > stream_t;


class el_cmp_class{
public:
  int compare(el_t &e1, el_t &e2)
  {
    if(e1.key_>e2.key_) 
      return 1;
    else 
      return -1;
  }
};

class pb_key_cmp_class{
public:
  bool operator()(const el_t &e1, const el_t &e2) const
  {
    if(e1.key_>e2.key_) 
      return true;
    else 
      return false;
  }
};

using namespace std;


int main(int argc, char **argv)
{
  el_cmp_class el_cmp_obj;
  uint el_num=0;
  double key=0;
  if(argc!=2)
    {
      cerr<<argv[0]<<" <# of elements>"<<endl;
      exit(0);
    }
  else
    {
      el_num=atol(argv[1]);
    }

  Random rand;
  char * base_file_stream = NULL;
  stream_t* is = (base_file_stream == NULL) ? new stream_t:
    new stream_t(base_file_stream);

  for(uint i=0; i<el_num;i++)
    {
      key=rand.uniform(1000,1000000)/100;
      is->write_item(el_t(key,i));
      //      cout<<key<<endl;
    }
  cout<<endl;
  if ((is->seek(0))!= AMI_ERROR_NO_ERROR) {
    cout << "AMI_ERROR during is->seek()" << endl;
    exit(1);
  }

  stream_t* ot=new stream_t;
  if((AMI_sort(is,ot,&el_cmp_obj))!=AMI_ERROR_NO_ERROR)
    {
      cerr<<"Sort err."<<endl;
      exit(0);
    }
  
  if ((ot->seek(0))!= AMI_ERROR_NO_ERROR) {
    cout << "AMI_ERROR during ot->seek()" << endl;
    exit(1);
  }

  el_t *tmp;
  AMI_err ae;
  for(uint i=0; i<el_num;i++)
    {
      if ((ae = ot->read_item(&tmp)) != AMI_ERROR_NO_ERROR) {
	cout << "AMI_ERROR " << ae << " during source.read_item()" << endl;
         exit(1);
      }
      cout<<tmp->key_<<endl;
    }

  if ((ot->seek(0))!= AMI_ERROR_NO_ERROR) {
    cout << "AMI_ERROR during ot->seek()" << endl;
    exit(1);
  }
  /*********************define pb_tree*********************/
  AMI_per_btree_params params = AMI_per_btree_params();
  AMI_btree_params rt_params = AMI_btree_params();
   
  AMI_PBTREE *p=new AMI_PBTREE("test_tree", AMI_WRITE_COLLECTION, params,rt_params);
  if (p->status() != AMI_PER_BTREE_STATUS_VALID){
    cout <<"Invalid tree : aborting\n\n";
    exit(0);
  }

  p->persist(PERSIST_PERSISTENT);
  int good=0;
    while (ot->read_item(&tmp) == AMI_ERROR_NO_ERROR) {  
    //cout<<tmp->
    if(p->insert(*tmp)) good++;

    //////////////////////
    /*if (pse->stype=='i'){
      //cout << pse->seg.x0 << "i\n";
      if(pbtree->insert(pse->seg,(s_long)pse->seg.x0)) good++;
    }
    if (pse->stype=='d'){
      //cout << pse->seg.x1 << "d\n";
      if(pbtree->erase(pse->seg,(s_long)pse->seg.x1)) good++;
      }*/
  } 
  return 0;
}
